from amsdal_data.connections.implementations.postgresql_state import PostgresStateConnection as PostgresStateConnection
from amsdal_data.table_schemas.base import TableSchemaServiceBase as TableSchemaServiceBase
from amsdal_data.table_schemas.data_models.sql_table_column import SqlTableColumn as SqlTableColumn
from amsdal_data.table_schemas.implementations.mixins.sql_statements_mixin import SqlStatementsMixin as SqlStatementsMixin
from amsdal_utils.models.data_models.address import Address as Address
from amsdal_utils.models.data_models.table_schema import TableSchema as TableSchema
from typing import Any

class PostgresStateTableSchemaService(SqlStatementsMixin, TableSchemaServiceBase):
    connection: PostgresStateConnection
    TABLE_SEPARATOR: str
    COLUMN_SEPARATOR: str
    @staticmethod
    def _to_sql_type(type_: Any) -> str: ...
    def register_table(self, table_schema: TableSchema, *, is_internal_table: bool = False) -> tuple[str, bool]: ...
    def create_index(self, table_name: str, column_name: str) -> None: ...
    def unregister_table(self, address: Address) -> None: ...
    def resolve_table_name(self, address: Address) -> str: ...
    def update_table(self, table_name: str, table_schema: TableSchema, table_columns: list[SqlTableColumn]) -> None: ...
    @staticmethod
    def _build_select_table_name_statement(table_name: str) -> tuple[str, list[Any]]: ...
    def create_table(self, table_name: str, table_schema: TableSchema, *, is_internal_table: bool = False) -> None: ...
    def register_internal_tables(self) -> None: ...
    def update_internal_table(self, table_schema: TableSchema) -> None: ...
